#include <bits/stdc++.h>
using namespace std;

bool messy_subtring(string, string);

int main() {
    ios_base::sync_with_stdio(false);

    /// INPUT

    int k; // Number of strings
    cin >> k;
    vector<string> x;
    for (int i = 0; i < k; i++) {
        string s;
        cin >> s;
        x.push_back(s);
    }

    /// ALGO

    int n = 1; // Start with 1 because the first string is always matching with itself, saves time on a trivial test.
    int n_biggest = 1; // Result

    string s_prev, s_cur;

    for (int i = 1; i < x.size(); i++) {
        s_prev = x[i - 1];
        s_cur = x[i];

        // If the previous string is a substring of the current one, increase the counter, otherwise reset counter (back to 1)
        if (messy_subtring(s_cur, s_prev)) {
            n++;
            if (n > n_biggest)
                n_biggest++;
        } else {
            n = 1;
            break;
        }
    }

    /// OUTPUT

    cout << n_biggest;

    return 0;
}

bool messy_subtring(string s_big, string s_smol) {
    for (int i = 0; i < s_smol.size(); i++) {
        char c = s_smol[i];

        // Find char in big string

        bool found = false;

        for (int j = 0; j < s_big.size(); j++) {
            char cc = s_big[j];
            if (c == cc) {
                found = true;
                s_big.erase(s_big.begin() + j);
                break;
            }
        }

        if (!found)
            return false;
    }
    return true;
}
