
import java.util.Scanner;

public class zetoni {

    public static final int tableSize = 101;

    static boolean[][] table = new boolean[tableSize][tableSize];

    public static void main(String[] args) {

        Scanner s = new Scanner(System.in);

        int steps = s.nextInt();

        int x = s.nextInt();
        int y = s.nextInt();

        int biggestX = x + 5;
        int biggestY = y + 5;

        if (x == 1 && y == 1) {
            System.out.println(0);
            return;
        }

        table[y][x] = true;

        for (int i = 0; i < steps - 1; i++) {
            x = s.nextInt();
            y = s.nextInt();

            if (x == 1 && y == 1) break;


            table[y][x] = true;

            if (checkTable(Math.max(biggestX, biggestY))) {
                printPath(i + 1);
                return;
            }

        }


        System.out.println(-1);
    }

    static boolean checkTable(int size) {

        int biggestX = 0;
        boolean foundOneX = false, foundOneY = false;
        for (int i = 1; i <= size; i++) {
            if (table[1][i]) {
                if (foundOneX) return false;
                foundOneX = true;
                biggestX = i;
            }
            if (table[i][1]) {
                if (foundOneY) return false;
                foundOneY = true;

            }
        }
        if (!(foundOneX && foundOneY)) return false;

        int index = 2;

        do {
            boolean foundOne = false;
            int biggestTemp = 0;
            for (int i = 1; i <= size; i++) {
                if (table[index][i]) {
                    if (foundOne) {
                        if (i >= biggestX) return false;
                    }
                    biggestTemp = i;
                    foundOne = true;

                }
            }
            biggestX = biggestTemp;
            if (!foundOne) return false;
            if (index > size) break;
            index++;
        } while (!table[index][1]);
        return true;
    }


    static void printPath(int time) {
        System.out.println(time + 1);

        for (int i = 1; i < tableSize; i++) {

            if (table[i][1]) break;

            for (int j = 1; j < tableSize; j++) {

                if (table[i][j]) break;
                System.out.println(i + " " + j);

            }


        }
    }

}
