#include <iostream>
#include <stack>

using namespace std;

bool indexed[1005][1005];
stack<int>koordinatex;
stack<int>koordinatey;
int resx[10000],resy[10000];

bool find()
{
    int i=1000;
    int j=1000;
    while(!indexed[i][j])
    {
        j--;
        if(!j)
        {
            j=1000;
            i--;
        }
    }
    if(i==1 && j==1)
    {
        int l=0;
        while(!koordinatex.empty())
        {
            resx[l]=koordinatex.top();
            resy[l]=koordinatey.top();
            l++;
            koordinatex.pop();
            koordinatey.pop();
        }
        return true;
    }
    while(i>0)
    {
        if(indexed[i][j]&&indexed[i+1][j-1]&&!indexed[i][j-1])
        {
            indexed[i][j]=false;
            indexed[i+1][j-1]=false;
            indexed[i][j-1]=true;
            koordinatex.push(i);
            koordinatey.push(j-1);
            if(find()) return true;
            indexed[i][j-1]=false;
            indexed[i][j]=true;
            indexed[i+1][j-1]=true;
            koordinatex.pop();
            koordinatey.pop();
        }
        j--;
        if(!j)
        {
            j=1000;
            i--;
        }
    }
    return false;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n,i,j,x,y;
    bool ok=false;
    cin>>n;
    if(n>1000) ok=true;
    for(i=1;i<=n;i++)
    {
        cin>>x>>y;
        indexed[x][y]=true;
        if(!ok && find())
        {
            ok=true;
            cout<<i<<endl;
            for(j=0;j<i-1;j++) cout<<resx[j]<<" "<<resy[j]<<endl;
        }
    }
    if(n>1000 || !ok) cout<<-1<<endl;
    return 0;
}
