#include <iostream>
#include <vector>

using namespace std;

static int mapa_in[1000][1000];
typedef struct
{
    int x, y;
} p2d;

int pokusaj(int zetona)
{
    int x = 1, y = 1;
    vector<p2d> tacke;
    for(;;)
    {
        p2d p;
        p.x = x;
        p.y = y;
        tacke.push_back(p);
        if ((mapa_in[x+1][y] == 0) && (mapa_in[x][y+1] == 0))
            return 0;
        if ((mapa_in[x+1][y] == 1) && (mapa_in[x][y+1] == 1))
        {
            unsigned int len = tacke.size();
            int br_udara = 0;
            for (unsigned int i = 0; i < len; i++)
            {
                p2d t = tacke.at(i);
                if (mapa_in[t.x+1][t.y] || mapa_in[t.x][t.y+1])
                    br_udara++;
            }
            if (zetona == br_udara)
            {
                cout << len + 1 << endl;
                for (unsigned int i = 0; i < len; i++)
                {
                    cout << tacke.at(i).x << ' ' << tacke.at(i).y;
                    cout << endl;
                }
            }
            return 1;
        }
        else if (!mapa_in[x+1][y])
            x++;
        else if (!mapa_in[x][y+1])
            y++;
    }
}

int main(void)
{
    int b = 1;
    int n, i;
    cin >> n;
    for (i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        mapa_in[x][y] = 1;
        if (pokusaj(i))
        {
            b = 0;
            break;
        }
    }
    if (b)
        cout << "-1" << endl;
    return 0;
}
