#include <iostream>
#include <string>
#include <vector>

using namespace std;

vector<int> countLetters(string one){
	vector<int> lfirst(26, 0);
	
	int len=one.length();
	
	for(int i=0; i<len; i++)
		lfirst[one[i]-65]++;
		
	return lfirst;
}

bool checkLetter(vector<int> a, vector<int> b){
	bool addedOne=false;

	
	for(int i=0; i<26; i++){
		if(b.at(i)==a.at(i)+1&&!addedOne)
			addedOne=true;
		else if((b.at(i)>a.at(i)+1)||(b.at(i)>a.at(i)&&addedOne)||(b.at(i)<a.at(i))){
			addedOne=false;
			break;
		}
	}

	return addedOne;
}

int main()	{
	int N, levels=1;
	bool broken=false;
	vector<int> lfirst, lsecond;
	string c[1000];
	cin>>N;
	
	for(int i=0; i<N; i++)
		cin>>c[i];
	
	lfirst = countLetters(c[0]);
	
	for(int i=1; i<N; i++){
		lsecond = countLetters(c[i]);
		
		if(checkLetter(lfirst, lsecond)&&!broken)
			levels++;
		else
			broken=true;

		lfirst=lsecond;
	}
	
	cout<<levels;
	
	return 0;
}
