#include <stdio.h>
#include <vector>
#include <algorithm>
#include <set>
//#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define mp make_pair
#define ll long long
const int N=500050;
const int M=2*N;
int bit[M],n;
int x[N],y[N],ans;
vector<pair<int,int> > step;
void input()
{
	scanf("%i",&n);
	for(int i=1;i<=n;i++) scanf("%i %i",&x[i],&y[i]);
}
void output()
{
	printf("%i\n",ans);
	if(ans!=-1)
	{
		for(int i=0;i<step.size();i++) printf("%i %i\n",step[i].first,step[i].second);
	}
}
vector<int> work[M];
void Try()
{
	int mx=-1;
	for(int i=1;i<=ans;i++) work[x[i]+y[i]-2].pb(x[i]),mx=max(mx,x[i]+y[i]-2);
	for(int i=mx;i>0;i--)
	{
		sort(work[i].begin(),work[i].end());
		for(int j=0,k;j<work[i].size();j=k)
		{
			for(k=j;k<work[i].size() && work[i][j]==work[i][k];k++);
			int sz=k-j;
			for(;k<work[i].size() && work[i][j]+1==work[i][k] && sz>0;k++)
			{
				sz--;
				work[i-1].pb(work[i][j]);
				step.pb(mp(work[i][j],i+2-work[i][j]-1));
			}
			if(sz!=0){ ans=-1;break;}
		}
		if(ans==-1) break;
	}
	if(ans!=-1 && work[0].size()==1) reverse(step.begin(),step.end());
	for(int i=0;i<=mx;i++) work[i].clear();
}
void Solve()
{
	ans=-1;
	int top=n,bot=1,mid;
	while(top>=bot)
	{
		mid=top+bot>>1;
		int mx=-1;
		for(int i=1;i<=mid;i++) bit[x[i]+y[i]-2]++,mx=max(mx,x[i]+y[i]-2);
		bool ok=1;
		for(int i=mx;i>0;i--)
		{
			if(bit[i]&1) ok=0;
			bit[i-1]+=bit[i]/2;
			bit[i]=0;
		}
		if(ok && bit[0]==1){ bit[0]=0;ans=mid;break;}
		if(bit[0]==0) bot=mid+1;
		else top=mid-1;
		bit[0]=0;
	}
	if(ans!=-1)
	{
		step.clear();
		Try();
	}
}
void Run()
{
	input();
	Solve();
	output();
}
/*multiset<pair<int,int> > all;
bool Simulate()
{
	all.clear();
	all.insert(mp(1,1));
	for(int i=0;i<step.size();i++)
	{
		if(!all.count(step[i])) return 0;
		all.erase(all.find(step[i]));
		all.insert(mp(step[i].first+1,step[i].second));
		all.insert(mp(step[i].first,step[i].second+1));
	}
	for(int i=1;i<=ans;i++)
	{
		if(!all.count(mp(x[i],y[i]))) return 0;
		all.erase(all.find(mp(x[i],y[i])));
	}
	return all.empty();
}
ll rnd()
{
	return ((ll)rand()<<25)^rand();
}
int bans;
void MakeTestCase()
{
    all.clear();
    all.insert(mp(1,1));
    bans=rnd()%500000+1;
    n=rnd()%(500000-bans+1)+bans;
    for(int i=2;i<=bans;i++)
    {
        int x=rand()%(min(i-1,10));
        multiset<pair<int,int> >::iterator it=all.begin();
        it=all.lower_bound(mp(rnd()%i+1,rnd()%i+1));
        while(x--)
        {
			if(it!=all.end()) it++;
		}
		if(it==all.end()) it--;
        all.insert(mp(it->first+1,it->second));
        all.insert(mp(it->first,it->second+1));
        all.erase(it);
    }
    vector<pair<int,int> > cool;
    for(multiset<pair<int,int> >::iterator it=all.begin();it!=all.end();it++) cool.pb(*it);
    random_shuffle(cool.begin(),cool.end());
    for(int i=1;i<=bans;i++) x[i]=cool[i-1].first,y[i]=cool[i-1].second;
    for(int i=bans+1;i<=n;i++) x[i]=rnd()%500000+1,y[i]=rnd()%500000+1;
}
void PrintTestCase()
{
	printf("%i\n",n);
	for(int i=1;i<=n;i++)
	{
		printf("%i %i\n",x[i],y[i]);
	}
	printf("Solve: %i\n",ans);
	printf("Brute: %i\n",bans);
}
bool Compare()
{
	if(ans!=bans) return 0;
	if(!Simulate()) return 0;
	return 1;
}
#define ldb long double
ldb s_time,e_time,d_time;
ldb GetTime(){ return (ldb)clock()/CLOCKS_PER_SEC;}
void Start(){ s_time=GetTime();}
void Stop(){ e_time=GetTime();d_time=e_time-s_time;}
void StressTest()
{
	srand(78651645);
	cout<<fixed<<setprecision(12);
	ldb mx_time=0;
	bool speed=1;
	for(int t=1;t<=1000;t++)
	{
		MakeTestCase();
		Start();
		Solve();
		Stop();
		mx_time=max(mx_time,d_time);
		if(!speed && !Compare())
		{
			PrintTestCase();
			return;
		}
		cout<<t<<": d_time="<<d_time<<"\n";
	}
	cout<<"AC mx_time="<<mx_time<<"\n";
}*/
int main()
{
	//bool test=1;
	//if(test) StressTest();
	//else
	Run();
    return 0;
}