#include <iostream>

using namespace std;

int zbirCifara(int broj){
    int zbir = 0;
    while (broj > 0){
        zbir += broj % 10;
        broj /= 10;
    }
    return zbir;
}

bool daLiJeKlepovPar(int i, int j, int k){
    return (j % k == 0) || (i * j % k == 0);
}


int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);

    int a, b, s, k;
    int brojKlepovihParova = 0;

    cin >> a >> b >> s >> k;

    b += 1;

    for (int i = a; i < b; ++i){
        if (zbirCifara(i) == s){
            if (i % k == 0){
                brojKlepovihParova += 1;
                for (int j = i + 1; j < b; ++j){
                    if (zbirCifara(j) == s){
                        brojKlepovihParova += 1;
                    }
                }
            }
            else {
                for (int j = i; j < b; ++j){
                    if (zbirCifara(j) == s){
                        if (daLiJeKlepovPar(i, j, k)){
                            brojKlepovihParova += 1;
                        }
                    }
                }
            }
        }
    }

    cout << brojKlepovihParova;

    return 0;
}
