#include <stdio.h>
#include <stdlib.h>

#define MAX(a,b) ((a) > (b) ? (a) : (b))
#define MIN(a,b) ((a) < (b) ? (a) : (b))

long long dif[1000000];
long long a, b, s, k, slen;

long long minSlep(long long s)
{
    long long x = 0, red = 1;
    while (s > 0)
    {
        x += red * MIN(s, 9);
        s -= MIN(s, 9);
    }

    return x;
}

int slep(long long x)
{
    int i;
    for (i = 0; x > 0; x /= 10)
    {
        i += x % 10;
    }
    return i == s;
}

int main()
{
    scanf("%lld%lld%lld%lld", &a, &b, &s, &k);
    slen = 0;
    long long start = minSlep(s) % 9;
    if (a % 9 == start)
        start = a;
    else if (a % 9 < start)
        start = a / 9 * 9 + start;
    else
        start = (a / 9 + 1) * 9 + start;
    for (long long i = start; i <= b; i += 9)
    {
        if (slep(i))
        {
            dif[slen++] = i;
        }
    }
    long long kl = 0;
    for (long long i = 0; i < slen; ++i)
    {
        for (long long j = i; j < slen; ++j)
        {
            if ((dif[i] * dif[j]) % k == 0)
                kl++;
        }
    }
    printf("%lld\n", kl);

    return 0;
}
