#include <iostream>
#include <queue>
#include <map>

// Burny was here 53729

using namespace std;

int n,brz=0;
int sol=-1;
map<pair<int,int>,int> mat;
queue<pair<int,int>> Q;
queue<pair<int,int>> Q2;
queue<pair<int,int>> QT;
vector<pair<int,int>> Vmoves;

void fold()
{
    while(!Q.empty())
    {
        pair<int,int> z=Q.front();
        Q.pop();
        if(mat[z]>0)
        {
            //cout<<"//"<<z.first<<" "<<z.second<<endl;
            if(mat[make_pair(z.first-1,z.second+1)]>0)
            {
                brz--;
                mat[make_pair(z.first,z.second)]--;
                mat[make_pair(z.first-1,z.second+1)]--;
                mat[make_pair(z.first-1,z.second)]++;
                //cout<<"Folded"<<z.first-1<<" "<<z.second<<endl;
                Vmoves.push_back(make_pair(z.first-1,z.second));
                Q.push(make_pair(z.first-1,z.second));
            }
            else if(mat[make_pair(z.first+1,z.second-1)]>0)
            {
                brz--;
                mat[make_pair(z.first,z.second)]--;
                mat[make_pair(z.first+1,z.second-1)]--;
                mat[make_pair(z.first,z.second-1)]++;
                //cout<<"Folded"<<z.first<<" "<<z.second-1<<endl;
                Vmoves.push_back(make_pair(z.first,z.second-1));
                Q.push(make_pair(z.first,z.second-1));
            }
            else
            {
                Q2.push(z);
            }
        }
    }
    QT=Q;
    Q=Q2;
    Q2=QT;
}

int main()
{
    iostream::sync_with_stdio(false);
    cin.tie(0);

    cin>>n;
    for(int i=0;i<n;i++)
    {
        int x,y;
        cin>>x>>y;
        Q.push(make_pair(x,y));
        mat[make_pair(x,y)]++;
        brz++;
        fold();
        if(brz==1 && mat[make_pair(1,1)]==1)
        {
            sol=i+1;
        }
    }
    cout<<sol<<endl;
    if(sol!=-1)
    {
        for(int j=Vmoves.size()-1;j>=0;j--)
        {
            pair<int,int> p=Vmoves[j];
            cout<<p.first<<" "<<p.second<<endl;
        }
    }
    return 0;
}
