#include <iostream>
#include <set>

using namespace std;

typedef unsigned long long ull;

static ull a, b, s, k;

static inline ull zbir_cifara(ull n)
{
    ull rez = 0;
    while (n != 0)
    {
        rez += n % 10;
        n /= 10;
    }
    return rez;
}

static inline ull resi()
{
    unsigned long long rez = 0;
    set<ull> slepi;
    //while (zbir_cifara(a) != s) a++;
    //while (zbir_cifara(b-1) != s) b--;
    for (ull i = a; i < b; i ++)
        if (zbir_cifara(i) == s)
            slepi.insert(i);
    for (auto a = slepi.begin(); a != slepi.end(); a++)
        for (auto b = a; b != slepi.end(); b++)
                if (!(((*a)*(*b))%k))
                    rez++;
    return rez;
}

int main()
{
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> a >> b >> s >> k;
    cout << resi();
    return 0;
}
