#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

inline bool checkSums(string& str1, string& str2)
{
	bool counted[256] = { false };
	unsigned short counts1[256] = { 0 };
	unsigned short counts2[256] = { 0 };
	unsigned short n1 = str1.length();
	unsigned short n2 = str2.length();
	bool aleradyInc = false;
	for (unsigned short i = 0; i < n1; ++i)
	{
		if (!counted[str1[i]])
		{
			counted[str1[i]] = true;
			counts1[str1[i]] = count(str1.begin(), str1.end(), str1[i]);
			counts2[str2[i]] = count(str2.begin(), str2.end(), str1[i]);
		}
	}
	for (unsigned short i = 0; i < n2; ++i)
	{
		if (!counted[str2[i]])
		{
			counted[str2[i]] = true;
			counts2[str2[i]] = count(str2.begin(), str2.end(), str2[i]);
		}
	}
	for (unsigned short i = 0; i < 256; ++i)
	{
		if ((counts1[i] + 1) == counts2[i])
		{
			if (aleradyInc)
				return false;
			aleradyInc = true;
		}

		if (counts1[i] < counts1[i])
			return false;
	}

	return true;
}

inline unsigned short countBools(string array[], unsigned short n)
{
	unsigned short count = 1;
	for (unsigned short i = 0; i < n - 1; ++i)
	{
		if (checkSums(array[i], array[i + 1])) ++count;
		else return count;
	}
	return count;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	string array[2500];
	unsigned short n;
	cin >> n;

	for (unsigned short i = 0; i < n; ++i)
	{
		cin >> array[i];
	}

	cout <<countBools(array, n) <<endl;
	return 0;
}