#include <stdio.h>
#include <stdlib.h>

void setPlace(int mat[101][101],int n,int x,int y)
{
    if (mat[x][y]==1)
    {
        mat[x][y]=0;
        setPlace(mat,n,x+1,y);
        setPlace(mat,n,x,y+1);
    } else mat[x][y]=1;
}

void printMat(int mat[101][101], int n)
{
    int i,j;
    for(i=1;i<n;i++)
    {
        for(j=1;j<n;j++) printf("%d",mat[i][j]);
        printf("\n");
    }
}

int cmpmat(int mat1[101][101],int mat2[101][101],int n)
{
    int i,j;
    for(i=1;i<n;i++)
    {
        for(j=1;j<n;j++) if (!(mat1[i][j]==mat2[i][j])) return 0;
    }
    return 1;
}

void copymat(int mat[101][101], int destmat[101][101],int n)
{
    int i,j;
    for(i=1;i<n;i++)
    {
        for(j=1;j<n;j++) destmat[i][j]=mat[i][j];
    }
}

int playGame(int mat[101][101],int tocmp[101][101],int n, int moves[10000][2],int k)
{
    if (cmpmat(mat,tocmp,n)){ return 1;}
    else
    {
        int i,j;
        for(i=1;i<n;++i)
        {
            for(j=1;j<n;++j)
            {
                if (tocmp[i][j]==1){
                    int destmat[101][101]={0};
                    copymat(tocmp,destmat,n);
                    setPlace(destmat,n,i,j);
                    int c,m;
                    int destmoves[10000][2]={0};
                    printf("---------------\n");
                    printMat(destmat,n);
                    for(c=0;c<k;++c)
                    {
                        for(m=0;m<2;++m) destmoves[c][m]=moves[c][m];
                    }
                    destmoves[k][0]=i;
                    destmoves[k][1]=j;
                    int k1;
                    k1 = k;
                    if (++k1<n) playGame(mat,destmat,n,destmoves,k1);
                }
            }
        }
    }
}

int main()
{
    int n,i,x,y,k=0;
    int mat[101][101]={0},tocmp[101][101]={0};
    int moves[10000][2]={0};
    scanf("%d",&n);
    for(i=0;i<n;++i)
    {
        scanf("%d%d",&x,&y);
        setPlace(mat,n,x,y);
    }
    setPlace(tocmp,n,1,1);
    k = 1;
    moves[0][0] = 1;
    moves[0][1] = 1;
    printf("-1");
    return 0;
}
