#include <stdlib.h>
#include <stdio.h>


void swap(long* a, long* b)
{
    long t = *a;
    *a = *b;
    *b = t;
}

long part(long l, long r, long* B)
{
    long i = l;
    long j;

    for(j=l; j<r; j++)
        if(B[j]<B[r])
        {
            swap(&B[i], &B[j]);
            i++;
        }
    swap(&B[i], &B[r]);

    return i;
}

void sort(long l, long r, long* B)
    {
        if(l<r)
        {
            long p = part(l, r, B);
            sort(l, p-1, B);
            sort(p+1, r, B);
        }
        return;
    }

int main()
{

    int n;
    scanf("%d", &n);
    long* B = (long*) malloc(805000*sizeof(long));
    short Bb[805000];

    long i;
    for(i=1; i<=(n*(n+1))/2; i++)
    {
        scanf("%li", &B[i]);
        Bb[i]=0;
    }
    sort(1, (n*(n+1))/2, B);


    long A[1300];
    Bb[1] = 1;
    Bb[2] = 1;
    Bb[3] = 1;
    A[1] = B[1];
    A[2] = B[2];
    int k, l;
    i=4;
    long j;
    long o;

    for(k=3; k<=n; k++)
    {
        while(Bb[i]==1)
            i++;
        A[k] = B[i];
        Bb[i] = 1;
        i++;
        j = i;
        for(l=1; l<k; l++)
        {
            o = A[l]|A[k];
            while(B[j]<o || Bb[j]==1)
                j++;
            Bb[j]=1;
            j++;
        }
    }

    for(k=1; k<n; k++)
        printf("%li ", A[k]);
    printf("%li", A[n]);

    return 0;
}
