#include <algorithm>
#include <cmath>
#include <cstdio>
#include <vector>

using namespace std;

/*
4
2 2
1 2
3 1
2 3



4
4 1
3 2
2 3
1 4

3
1 2
2 1
3 0


*/

typedef struct {
    int x, y;
} Point;

vector<Point> potezi;
vector<Point> resenja;
bool imax[500007] = {false};
bool imay[500007] = {false};
vector<Point> levels[500007];

bool customsort(Point a, Point b) {
    return a.x < b.x;
}

int main() {
    // Input.
    int n;
    Point p;
    scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
        scanf("%d %d", &p.x, &p.y);
        --p.x;
        --p.y;
        potezi.push_back(p);
    }
    // Loop.
    int maxx = -1,
        maxy = -1,
        missx = -1,
        missy = -1,
        maxabs = -1,
        absol = 0,
        i,
        poww = 1;
    bool found = false;
    for (i = 0; i < n; ++i) {
        p = potezi[i];
        if (missx == -1) {
            maxx = p.x;
            missx = p.x;
            maxy = p.y;
            missy = p.y;
            imax[p.x] = true;
            imay[p.y] = true;
            // printf("Initial miss %d %d\n", missx, missy);
        } else {
            if (p.x > maxx) {
                missx += p.x - maxx - 1;
                maxx = p.x;
                // printf("missx increased to %d\n", missx);
            } else if (!imax[p.x]) {
                --missx;
                // printf("Decreasing missx\n");
            }
            imax[p.x] = true;
            if (p.y > maxy) {
                missy += p.y - maxy - 1;
                maxy = p.y;
                // printf("missy increased to %d\n", missy);
            } else if (!imay[p.y]) {
                --missy;
                // printf("Decreasing missy\n");
            }
            imay[p.y] = true;
        }
        int abso = p.x + p.y;
        levels[abso].push_back(p);
        if (maxabs < abso) {
            poww = pow(2, abso);
            absol *= pow(2, abso - maxabs);
            maxabs = abso;
        }
        absol += pow(2, maxabs - abso);
        // printf("%d %d %d %d %d %d\n", p.x, p.y, maxx, maxy, missx, missy);
        if (absol == poww && missx == 0 && missy == 0) {
            found = true;
            break;
        }
    }
    if (found) {
        printf("%d\n", maxabs + 1);
        while (maxabs != 0) {
            sort(levels[maxabs].begin(), levels[maxabs].end(), customsort);
            for (int i = 0; i < levels[maxabs].size(); i += 2) {
                p.x = levels[maxabs][i].x;
                p.y = levels[maxabs][i].y - 1;
                levels[maxabs - 1].push_back(p);
                resenja.push_back(p);
            }
            --maxabs;
        }
        for (int i = resenja.size() - 1; i >= 0; --i) {
            printf("%d %d\n", resenja[i].x + 1, resenja[i].y + 1);
        }
    } else {
        printf("-1");
    }
    return 0;
}
