#include <bits/stdc++.h>

using namespace std;

#define MAXN 200009

int A[MAXN];
int group_sums[MAXN];

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0);

    int n, l;
    long long total = 0;
    cin >> n >> l;

    int num = 0;
    for (int i = 0; i < n; i++) {
        cin >> num;
        A[i] = num;
        group_sums[i%l] += num;
        total += num;
    }

    if (total % l != 0) {
        cout << 0;
        return 0;
    }
    int target = total / l;
    int count_incorrect = 0;
    vector<int> wrong_mod;

    for (int i = 0; i < l; i++) {
        if (group_sums[i] != target) {
            count_incorrect++;
            if (count_incorrect > 2) {
                cout << 0;
                return 0;
            }
            wrong_mod.push_back(i);
        }
    }

    if (count_incorrect == 0) {
        // number of groups * elements per grp - 1
        cout << (l * (n/l-1));
        return 0;
    }
    // sad mora da bude c_i == 2 valjda

    vector<int> w1(n/l, 0);
    vector<int> w2(n/l, 0);

    int idx = 0;
    long long sumw1 = 0;
    unordered_map<int, int> w1counts;
    for (int i = wrong_mod[0]; i < n; i += l) {
        w1[idx] = A[i];
        sumw1 += A[i];
        idx++;

        if (w1counts.find(A[i]) != w1counts.end())
        {
            w1counts[A[i]]++;
        }
        else {
            w1counts[A[i]] = 1;
        }
    }

    idx = 0;
    long long sumw2 = 0;
    unordered_map<int, int> w2counts;
    for (int i = wrong_mod[1]; i < n; i += l) {
        w2[idx] = A[i];
        if (w2counts.find(A[i]) != w2counts.end())
        {
            w2counts[A[i]]++;
        }
        else {
            w2counts[A[i]] = 1;
        }
        sumw2 += A[i];
        idx++;
    }

    int res = 0;
    int need = target - sumw1;
    for (int i = 0; i < w2.size(); i++) {
        int nd = need + A[i];
        if (w2counts.find(nd) != w2counts.end())
        {
            res += w2counts[nd];
        }
    }

    need = target - sumw2;
    for (int i = 0; i < w2.size(); i++) {
        int nd = need + A[i];
        if (w1counts.find(nd) != w1counts.end())
        {
            res += w1counts[nd];
        }
    }

    cout << res;

    return 0;
}
