#include <stdio.h>

long long gcd(long long a, long long b)
{
    if( b == 0 ) return a;
    return gcd(b, a%b);
}

int saberi(long long a, int s)
{
    if(a != 0) return saberi(a/10, s+(a%10));
    return s;
}

long long fak(long long br, long long zbir)
{
    if (br != 0) return fak(br-1, zbir + br);
    return zbir;
}

int main()
{
    int s;
    long long a, b, k;

    scanf("%lld%lld%d%lld", &a, &b, &s, &k);
    long long x[1000010];

    int br = 0;
    for(long long i=a; i<=b; i++)
    {
        int z = saberi((long long)i, 0);
        if(z == s)
        {
            x[br] = i;
            br++;
        }
    }

    long long d = 0;
    if ( k == 1 ) d = fak(br, 0);
    else
    {
        for(int i=0; i<br; i++)
            for(int j=i; j<br; j++)
                if((x[i] % k == 0) || (x[j] % k == 0)) d++;
                else if(((gcd(x[i],k) * gcd(x[j],k)) % k == 0)) d++;
    }

    printf("%lld", d);
}
