#include <iostream>
#include <vector>
#include <algorithm>

int main()
{
    std::ios::sync_with_stdio(false);
    int N, L;
    std::cin >> N >> L;
    std::vector<std::vector<int>> B(N/L + 1, std::vector<int>(2000001, 0));
    std::vector<int> A(N);
    std::vector<long long> S(N/L, 0);
    int mi = 2000001, ma = -1;
    for(int i = 0; i < N; i++)
    {
        std::cin >> A[i];
        mi = std::min(mi, A[i]);
        ma = std::max(ma, A[i]);
        B[i/L][A[i]]++;
        S[i/L] += A[i];
    }
    for(int j = 0; j < N/L; j++) for(int i = mi; i <= ma; i++) B[N/L][i] += B[j][i];
    bool svi_isti = true;
    long long brn = 0;
    for(int i = 1; i < N/L; i++) if(S[i] != S[0]) svi_isti = false;
    if(svi_isti)
    {
        for(int j = 0; j < N/L; j++) for(int i = mi; i <= ma; i++)
                if(B[N/L][i] > 1)
                {
                    B[N/L][i] -= B[j][i];
                    brn += B[j][i]*B[N/L][i];
                }
        brn += (((long long)L*(long long)(L-1))/2)*(long long)(N/L);
    }
    std::cout << brn;
    return 0;
}
