#include <iostream>
#include <vector>
#include <string>

std::vector<std::string> pir;
int P = 0;
std::vector<int> sl1, sl2(26, 0);

void piramida(int n);
void izbroj_slova(std::string &s)
{
    sl1.clear();
    sl1.assign(26, 0);
    for(int i = 0; i < s.size(); i++) sl1[s[i]-'A']++;
}

int main()
{
    std::ios::sync_with_stdio(false);
    int N;
    std::cin >> N;
    pir.resize(N);
    for(int i = 0; i < N; i++) std::cin >> pir[i];
    piramida(0);
    std::cout << P;
    return 0;
}

void piramida(int n)
{
    izbroj_slova(pir[n]);
    bool postoji = false;
    for(int i = 0; i < 26; i++)
        if(sl1[i] != sl2[i])
        {
            if(sl1[i] - 1 == sl2[i])
            {
                if(!postoji)
                {
                    postoji = true;
                    sl2[i]++;
                }
                else
                {
                    postoji = false;
                    break;
                }
            }
            else
            {
                postoji=false;
                break;
            }
        }
    if(postoji)
    {
        P++;
        piramida(n + 1);
    }
}

