#include <bits/stdc++.h>
using namespace std;

const int mx = 5e5+5;
int n, bz;
multiset<int> m[mx];
vector<pair<int, int>> moves;

bool pos(int x, int y) {
    return m[x].count(y);
}

void ins(int x, int y) {
    m[x].insert(y);
}

void ers(int x, int y) {
    m[x].erase(m[x].find(y));
}

bool check(int x, int y) {
    if (pos(x+1, y) && pos(x, y+1)) {
        ins(x, y);
        ers(x+1, y);
        ers(x, y+1);
        return true;
    }
    return false;
}

void go(int x, int y) {
    if (check(x-1, y)) {
        bz--;
        moves.push_back({x-1, y});
        go(x-1, y);
    }
    if (check(x, y-1)) {
        bz--;
        moves.push_back({x, y-1});
        go(x, y-1);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    cin >> n; bool done = false;
    for (int i = 1; i <= n; i++) {
        int x, y; cin >> x >> y;
        if (done) continue;
        ins(x, y); bz++;
        go(x, y);
        if (bz == 1 && pos(1, 1)) {
            done = true;
        }
    }

    if (done) {
        cout << moves.size()+1 << '\n';
        reverse(moves.begin(), moves.end());
        for (auto x : moves)
        cout << x.first << ' ' << x.second << '\n';
    }
    else cout << "-1\n";
}
