#include <iostream>
#include <vector>
#include <string>

int zbir_cifara(int broj) {
	int suma = 0;
	while(true) {
		suma += broj % 10;
		broj = broj / 10;
		if(broj == 0) {
			return suma;
		}
	}
}

int main() {
	
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	
	int A, B, S, K;
	std::string ulaz;
	std::getline(std::cin, ulaz);
	
	A = std::stoi(ulaz.substr(0, ulaz.find(" ")));
	ulaz = ulaz.substr(ulaz.find(" ")+1);
	B = std::stoi(ulaz.substr(0, ulaz.find(" ")));
	ulaz = ulaz.substr(ulaz.find(" ")+1);
	S = std::stoi(ulaz.substr(0, ulaz.find(" ")));
	ulaz = ulaz.substr(ulaz.find(" ")+1);
	K = std::stoi(ulaz);
	
	std::vector<int> slepi_brojevi;
	
	for(int i = A; i < B; i++) {
		int zbir = zbir_cifara(i);
		if(zbir == S) {
			slepi_brojevi.push_back(i);
		}
	}
	
	int ukupno = 0;
	
	for(int i = 0; i < slepi_brojevi.size(); i++) {
		for(int j = i; j < slepi_brojevi.size(); j++) {
			if(slepi_brojevi[i] * slepi_brojevi[j] % K == 0) {
				ukupno++;
			}
		}
	}
	
	std::cout << ukupno;
	
	return 0;
}