#include <iostream>
#include <vector>
#include <string>

struct pos {
	int x, y;
};

bool proveri(int& dubina, std::vector<pos>& tabla, int max, int sledeci, std::vector<pos>& konacna_tabla, std::vector<pos>& koraci) {
	bool sve_dobro = true;
	
	for(int i = 0; i < tabla.size(); i++) {
		bool postoji = false;
		for(int j = 0; j < konacna_tabla.size(); j++) {
			if(tabla[i].x == konacna_tabla[j].x && tabla[i].y == konacna_tabla[j].y)  {
				postoji = true;
			}
		}
		if(!postoji) {
			sve_dobro = false;
			break;
		}
	}
	
	if(sve_dobro) {
		return true;
	}
	
	std::vector<pos> nova_tabla;
	
	for(int i = 0; i < tabla.size(); i++) {
		if(i != sledeci) {
			nova_tabla.push_back(tabla[i]);
		}
	}
	nova_tabla.push_back({tabla[sledeci].x+1, tabla[sledeci].y});
	nova_tabla.push_back({tabla[sledeci].x, tabla[sledeci].y+1});
	tabla.empty();
	
	if(dubina < max) {
		dubina++;
		for(int i = 0; i < tabla.size(); i++) {
			std::vector<pos> temp = nova_tabla;
			bool pokusaj = proveri(dubina, temp, max, i, konacna_tabla, koraci);
			koraci.push_back(tabla[i]);
			if(pokusaj) {
				return true;
			}else{
				koraci.pop_back();
			}
		}
		dubina--;
	}
	
	return false;
}

int main() {
	
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	
	int N;
	std::vector<pos> konacno;
	std::vector<pos> cilj;
	std::vector<pos> novo = {{1,1}};
	std::vector<pos> koraci;
	
	std::string tmp;
	std::getline(std::cin, tmp);
	N = std::stoi(tmp);
	
	for(int i = 0; i < N; i++) {
		std::string red;
		std::getline(std::cin, red);
		int a = std::stoi(red.substr(0, red.find(" ")));
		int b = std::stoi(red.substr(red.find(" ")+1));
		konacno.push_back({a, b});
	}
	
	bool reseno = false;
	int korak = 0;
	int dubina = 0;
	
	for(int i = 0; i < konacno.size(); i++) {
		cilj.push_back(konacno[i]);
		reseno = proveri(dubina, novo, i, 0, cilj, koraci);
		
		if(reseno) {
			korak = i+1;
			break;
		}else{
			novo = {{1,1}};
		}
		
	}
	
	if(reseno) {
		std::cout << korak << '\n';
		for(int i = 0; i < koraci.size(); i++) {
			std::cout << koraci[koraci.size()-i-1].x << " " << koraci[koraci.size()-i-1].y;
			if(i < koraci.size() - 1) {
				std::cout << '\n';
			}
		}
	}else{
		std::cout << -1;
	}
	
	return 0;
}