using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace zetoni
{
    class Par:IComparable
    {
        int x, y;
        public Par(int x1, int y1)
        {
            x = x1;
            y = y1;
        }
        public int X
        { get { return x; } }
        public int Y
        { get { return y; } }
        public int CompareTo(object obj)
        {
            Par p = (Par)obj;
            if (this.x < p.x || (this.x == p.x && this.y < p.y)) return -1;
            else if (this.x > p.x || (this.x == p.x && this.y < p.y)) return 1;
            else return 0;
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            Par[] p = new Par[n];
            for (int i = 0; i < n; i++)
            {
                string[] r = Console.ReadLine().Split(' ');
                p[i] = new Par(int.Parse(r[0]), int.Parse(r[1]));
            }
            Par[] pk = new Par[n];
            bool moze = true;
            for (int k = 0; k < n; k++) 
            {
                pk[k] = (new Par(p[k].X, p[k].Y));
                Array.Sort(pk);
                Par[] izlaz = new Par[n];
                for (int i = n - k - 1; i < n; i++)  //pk[i] je par dobijen i-1 poteza od 1,1
                {
                    if (pk[i] == null) continue;
                    int xi = pk[i].X;
                    int yi = pk[i].Y;
                    if ((xi + yi) != k+3) { moze = false; break; }
                    else
                    {
                        if (xi > 1) izlaz[i] = new Par(xi - 1, yi);
                        else izlaz[i] = new Par(xi, yi - 1);
                    }
                }
                if (moze) 
                {
                    Console.WriteLine(k + 1);
                    for (int i = 0; i < izlaz.Length; i++)
                    {
                        Console.WriteLine(izlaz[i]);
                    }
                    Console.ReadLine();
                    return;
                }
            }
            Console.WriteLine("-1");
            Console.ReadLine();
            return;
        }
    }
}
