using System;
using System.Linq;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            // B2. Fotografisanje

            int N = int.Parse(Console.ReadLine());
            int[] vremena = Console.ReadLine().Split(' ').Select(v => int.Parse(v)).ToArray();
            int[] pauze = new int[N - 1]; int maxpauzai = -1, maxpauza = -1;
            for (int i = 0; i < N - 1; i++)
            {
                int pauzai = pauze[i] = vremena[i + 1] - vremena[i];
                if (maxpauza != -1 && pauzai <= maxpauzai) continue;
                maxpauza = i;
                maxpauzai = pauzai;
            }

            if (maxpauza == 0)
                // 1. prva pauza je najveca - prebaciti prvog da ide s drugim
                Console.WriteLine("{0} {1}", 1, vremena[1]);
            else if (maxpauza == N - 1)
                // 2. poslednja pauza je najveca - prebaciti poslednjeg da ide s pretposlednjim
                Console.WriteLine("{0} {1}", N, vremena[N - 2]);
            else
            {
                // 3. neka izmedju pauza je najveca
                // levog ili desnog postaviti u sredinu
                // u zavisnosti od toga koji najvise smanjuje pauzu
                int vreme1 = vremena[maxpauza - 1];
                int vreme2 = vremena[maxpauza];
                int vreme3 = vremena[maxpauza + 1];
                int vreme4 = vremena[maxpauza + 2];

                int pauza1 = vreme2 - vreme1;
                int pauza2 = vreme3 - vreme2;
                int pauza3 = vreme4 - vreme3;

                int mreme2 = vreme1 + (pauza1 + pauza2) / 2;
                int mreme3 = vreme2 + (pauza2 + pauza3) / 2;

                int pauza12 = mreme2 - vreme1;
                int pauza22 = vreme3 - mreme2;
                int pauza23 = mreme3 - vreme2;
                int pauza33 = vreme4 - mreme3;

                if (Math.Max(pauza12, pauza22) <= Math.Max(pauza23, pauza33))
                    // promeniti levi termin je najbolje
                    Console.WriteLine("{0} {1}", maxpauza + 1, mreme2);
                else
                    // promeniti desni termin je najbolje
                    Console.WriteLine("{0} {1}", maxpauza + 2, mreme3);
            }
        }
    }
}
