#include <iostream>
#include <cstdio>
#include <queue>

using namespace std;

int sum(long long n){
    int s = 0;
    for(; n > 0; n /= 10)
        s += n%10;
    return s;
}

long long *queueToArray(queue<long long> p){
    long long *x = new long long[p.size()];
    for(int i = 0; !p.empty(); i++, p.pop())
        x[i] = p.front();
    return x;
}

void output(int n, long long *x){
    for(int i = 0; i < n; i++)
        printf("%lld ", x[i]);
}

int main(){
    long long a, b, s, k;
    cin >> a >> b >> s >> k;
    queue<long long> p;
    for(int i = a; i <= b; i++)
        if(sum(i) == s)
            p.push(i);
    long long *x, n = p.size();
    x = queueToArray(p);
    //output(n, x);

    int r = 0;
    for(int i = 0; i < n; i++)
        for(int j = 0; j <= i; j++)
            if(x[i]*x[j]%k == 0)
                r++;
    cout << r;

    delete[] x;
    return 0;
}
