#include <iostream>
#include <string>
#include <vector>

bool check(char c, const std::string &curr, std::vector<bool> &valid);

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int N, P = 1;
    std::cin >> N;
    char first_letter;
    std::cin >> first_letter;
    std::string prev;
    prev.push_back(first_letter);
    for (int i = 1; i != N; ++i) {
        std::string next;
        std::cin >> next;
        std::vector<bool> valid(next.size(), true);
        for (const auto &c : prev)
            if (!check(c, next, valid)) {
                std::cout << P << std::endl;
                return 0;
            }
        int valid_index = -1;
        for (int i = 0; i != valid.size(); ++i)
            if(valid[i]) {
                if (valid_index != -1) {
                    std::cout << P << std::endl;
                    return 0;
                }
                valid_index = i;
            }
        if (valid_index == -1) {
            std::cout << P << std::endl;
            return 0;
        }
        prev.push_back(next[valid_index]);
        ++P;
    }
    std::cout << P << std::endl;
    return 0;
}
bool check(char c, const std::string &curr, std::vector<bool> &valid)
{
    for (int i = 0; i != curr.size(); ++i)
        if (c == curr[i] && valid[i]) {
            valid[i] = false;
            return true;
        }
    return false;
}
