#include <cstdio>
#include <new>
#include <algorithm>

using namespace std;

int digitSum(int a);
void findSlepi(int a, int b, int s, int* out, int* j);
int nzs(int a, int b);


int main()
{
    int a = 0;
    int b = 0;
    int s = 0;
    int k = 0;
    int n = 0;

    scanf("%d %d %d %d", &a,&b,&s,&k);
    int* out = new int[b-a];

    findSlepi(a,b,s,out,&n);

    int num = 0;

    for(int i = 0; i<n;i++){
        int nz = nzs(out[i],k);
        int lf = nz/out[i];
        for(int j = 0; j<n;j++){
            if(lf%out[j]) num++;
        }
    }

    printf("%d", num);

    return 0;
}

void findSlepi(int a, int b, int s, int* out, int* j)
{
    *j = 0;
    for(int i = a; i<=b;i++){
        if(digitSum(i) == s)
        {
            out[*j] = i;
            *j = *j +1;
        }
    }
}

int digitSum(int a)
{
    int sum = 0;
    while(a!=0){
        sum+= a%10;
        a/=10;
    }
    return sum;
}

int nzs(int a, int b){
    int n =1;
    int i = 2;
    int copy_a = a;
    int copy_b = b;

    while(i<=copy_a/2 || i<=copy_b/2){
        if(a == 1 && b==1) break;
        if(a%i == 0 || b%i == 0) {
            if(a%i == 0){
                a/=i;
            }
            if(b%i == 0){
                b/=i;
            }
            n*=i;
        }else{
            i++;
        }
    }
    if(a != 1) n*=copy_a;
    if(b != 1) n*=copy_b;

    return n;
}

