#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>

#define MAXNN 1610000
#define MAXN 1500

using namespace std;

void unos(int a[],int &n,bool x[])
{
    scanf("%d",&n);
    for(int i=0;i<n*(n+1)/2;i++){
        scanf("%d",&a[i]);
        x[i]=false;
    }
}

void ispis(int a[],int n)
{
    for(int i=0;i<n;i++)
        printf("%d ",a[i]);
}

bool ne_sadrzi(int b[],int m,int a)
{
    int k=0;
    for(int i=0;i<m;i++){
        k=k|b[i];
        if((k&a)==a){
            //cout<<b[i]<<" "<<a<<endl;
            return 0;
        }
    }
    return 1;
}

void rac(int p[],int a)
{
    int i=0;
    while(a>0)
    {
        if(a%2)
            p[i]++;
        a/=2;
        i++;
    }
}

void isk(int a[],int n,int b,bool x[])
{
    int s=1;
    for(int i=1;i<b;i++)
        s*=2;
    for(int i=0;i<n*(n+1)/2&&b>0;i++)
        if((a[i]/s)%2){
            x[i]=true;
            //cout<<i<<endl;
        }
}

void iskljuci(int a[],int b[],int &m,int n,bool x[])
{
    int p[20],q[20],r,k;
    for(int i=0;i<20;i++)
        p[i]=q[i]=0;
    for(int i=0;i<n*(n+1)/2;i++)
        if(!x[i])
            rac(p,a[i]);
        else
            rac(q,a[i]);
    /*ispis(p,20);
    cout<<endl;
    ispis(q,20);
    cout<<endl;*/
    for(int i=0;i<20;i++)
    {
        r=2*(p[i]+q[i])-n*n-n;
        k=(1+sqrt(1-4*r))/2;
        if(n-k+1==q[i]&&q[i]!=0){
            //cout<<i<<endl;
            isk(a,n,i,x);
        }
    }
}

bool resenje(int a[],int b[],int m,int n)
{
    int x[MAXNN],n1=0;
    int *p;
    if(m!=n)
        return false;
    for(int i=0;i<m;i++)
        for(int j=i;j<m;j++){
            x[n1]=b[i]|b[j];
            n1++;
        }
    sort(x,x+n1);
    for(int i=0;i<n*(n+1)/2;i++)
        if(x[i]!=a[i])
            return 0;
    return 1;
}

void glavna(int a[],int b[],int &m,int n,bool x[]);

void brute_force(int a[],int b[],int &m,int n,bool x[])
{
    for(int i=0;i<n*(n+1)/2;i++)
        if(!x[i])
        {
            b[m]=a[i];
            x[i]=true;
            m++;
            glavna(a,b,m,n,x);
            if(resenje(a,b,m,n))
                return;
            m--;
            x[i]=false;
        }
}

void glavna(int a[],int b[],int &m,int n,bool x[])
{
    for(int i=0;i<n*(n+1)/2;i++)
    {
        //cout<<i<<" "<<ne_sadrzi(b,m,a[i])<<endl;

        if(ne_sadrzi(b,m,a[i])&&!x[i])
        {
            b[m]=a[i];
            //cout<<" "<<i<<endl;
            x[i]=true;
            m++;
        }
    }
    if(m==n)
        return;
    iskljuci(a,b,m,n,x);
    brute_force(a,b,m,n,x);
}

int main()
{
    int n,a[MAXNN],b[MAXN],m=0;
    bool x[MAXNN];
    unos(a,n,x);
    sort(a,a+n*(n+1)/2);
    glavna(a,b,m,n,x);
    ispis(b,n);
    /*cout<<endl;
    ispis(a,n*(n+1)/2);*/

    return 0;
}
