#include <stdio.h>
#include <set>
#include <algorithm>
//#include <ctime>
//#include <stdlib.h>
//#include <iostream>
//#include <bits/stdc++.h>
using namespace std;
#define ll long long
const int N=2050;
const int M=N*N;
const int lim=1<<20;
int n,b[M],a[N],m;
int cnt[lim];
bool can;
void input()
{
	scanf("%i",&n);
	m=n*(n+1)/2;
	for(int i=1;i<=m;i++) scanf("%i",&b[i]);
	sort(b+1,b+1+m);
}
void output()
{
	for(int i=1;i<=n;i++) printf("%i ",a[i]);
}
void Solve()
{
	can=1;
	for(int i=1;i<=m;i++) cnt[b[i]]++;
	int ptr=1;
	for(int i=1;i<=n;i++)
	{
		for(;cnt[ptr]==0;ptr++);
		a[i]=ptr;
		for(int j=1;j<=i;j++)
		{
			if(cnt[a[i]|a[j]]==0)
			{
				can=0;
				for(int k=0;k<lim;k++) cnt[k]=0;
				return;
			}
			cnt[a[i]|a[j]]--;
		}
	}
}
void Run()
{
	input();
	Solve();
	output();
}
bool Check(int x[])
{
	multiset<int> all;
	for(int i=1;i<=m;i++) all.insert(b[i]);
	for(int i=1;i<=n;i++) for(int j=i;j<=n;j++)
	{
		if(!all.count(x[i]|x[j])) return 0;
		all.erase(all.find(x[i]|x[j]));
	}
	return 1;
}
/*int bans[N];
bool bcan;
void Brute()
{
	vector<int> work(m,0);
	for(int i=0;i<n;i++) work[i]=1;
	sort(work.begin(),work.end());
	bcan=0;
	do
	{
		int c=0;
		for(int i=0;i<m;i++) if(work[i]==1) bans[++c]=b[i+1];
		if(Check(bans)){ bcan=1;return;}
	}while(next_permutation(work.begin(),work.end()));
}
ll rnd()
{
	return ((ll)rand()<<25)^rand();
}
void MakeTestCase()
{
	n=rnd()%1268+1;
	m=n*(n+1)/2;
	for(int i=1;i<=n;i++) a[i]=rnd()%((1<<20)-1)+1;
	int c=0;
	for(int i=1;i<=n;i++) for(int j=i;j<=n;j++) b[++c]=a[i]|a[j];
	//for(int i=1;i<=m;i++) b[i]=rnd()%((1<<20)-1)+1;
	sort(b+1,b+1+m);
}
void PrintTestCase()
{
	printf("%i\n",n);
	for(int i=1;i<=m;i++) printf("%i ",b[i]);printf("\n");
	printf("Solve %i:",can);for(int i=1;i<=n;i++) printf("%i ",a[i]);printf("\n");
	printf("Brute %i:",bcan);for(int i=1;i<=n;i++) printf("%i ",bans[i]);printf("\n");
}
bool Compare()
{
	if(bcan && !can) return 0;
	if(can && !Check(a)) return 0;
	return 1;
}
#define ldb long double
ldb s_time,e_time,d_time;
ldb GetTime(){ return (ldb)clock()/CLOCKS_PER_SEC;}
void Start(){ s_time=GetTime();}
void Stop(){ e_time=GetTime();d_time=e_time-s_time;}
void StressTest()
{
	srand(78651645);
	cout<<fixed<<setprecision(12);
	ldb mx_time=0;
	bool speed=1;
	int res=0;
	for(int t=1;t<=1000;t++)
	{
		MakeTestCase();
		Start();
		Solve();
		Stop();
		if(!speed)Brute();
		mx_time=max(mx_time,d_time);
		if(!can)
		{
			printf("???\n");
			return;
		}
		//if(!Compare() && !speed)
		//{
		//	PrintTestCase();
		//	return;
		//}
		cout<<t<<": d_time="<<d_time<<"\n";
		res+=can;
	}
	cout<<"AC mx_time="<<mx_time<<" res="<<res<<"\n";
}*/
int main()
{
	//bool test=1;
	//if(test) StressTest();
	//else
	Run();
    return 0;

}