#include <bits/stdc++.h>
#define MAX_N 500010
using namespace std;
struct tacka{
    int x, y;
public:
    bool operator<(const tacka& rhs) const{
        if(x+y<rhs.x+rhs.y) return 1;
        if(x+y>rhs.x+rhs.y) return 0;
        return x<rhs.x;
    }
};

int N;
tacka t[MAX_N];
vector<tacka> potezi;
int cntud[2*MAX_N];
priority_queue<tacka> pq;

bool vrednost(int k){
    //radi u O(k+maxdi)
    //vraca 1 ako je vrednost pozicije dovoljna za kraj, -1 ako je premala

    int maxdi=0;
    for(int i=0; i<=k; ++i){
        cntud[t[i].x+t[i].y]++;
        if(t[i].x+t[i].y>maxdi)maxdi=t[i].x+t[i].y;
    }
    //printf("Proveram k=%d\n", k);
    //for(int i=0; i<=maxdi; ++i)printf("cntud[%d]=%d\n", i, cntud[i]);
    int val=0;
    for(int i=maxdi; i>=3; --i){
        val+=cntud[i];
        val/=2;
    }
    memset(cntud, 0, (maxdi+3)*sizeof(int));
    //ostaje nam val u drugom nivou
    if(val>=1) return 1;
    return 0;
}

void check(int k){
    for(int i=0; i<=k; ++i)pq.push(t[i]);
    while(!pq.empty()){
        tacka A=pq.top();
        pq.pop();
        if(A.x==1 && A.y==1 && pq.empty()){
            break;
        }
        int broj_A=1;
        if(pq.empty()){
            printf("-1");
            return;
        }
        tacka B=pq.top();
        while(B.x==A.x && B.y==A.y){
            broj_A++;
            pq.pop();
            if(pq.empty()){
                printf("-1");
                return;
            }
            B=pq.top();
        }
        while(broj_A>0 && A.x==B.x+1 && A.y==B.y-1){
            pq.pop();
            tacka C;
            C.x=A.x-1;
            C.y=A.y;
            pq.push(C);
            potezi.push_back(C);
            broj_A--;
            B=pq.top();
        }
        if(broj_A>0){
            printf("-1");
            return;
        }
    }
    int d=potezi.size();
    cout<<k+1<<endl;
    for(int i=d-1; i>=0; --i){
        cout<<potezi[i].x<<" "<<potezi[i].y<<endl;
    }

}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin>>N;
    for(int i=0; i<N; ++i){
        cin>>t[i].x>>t[i].y;
    }
    //trazimo prvo mesto gde je pozicija dovoljno velika
    int d=0, g=N-1;
    if(vrednost(g)==0){
        printf("-1");
        return 0;
    }
    while(g>d+1){
        int mid=(d+g)/2;
        if(vrednost(mid))g=mid;
        else d=mid;
    }
    //[0...g] je podniz koji je dovoljan
    check(g);
    return 0;
}
/*
4
2 2
1 2
3 1
2 3

4
4 1
3 2
2 3
1 4

8
4 1
3 2
2 3
1 4
3 2
3 2
2 3
2 3

10
1 3
2 3
2 2
3 2
3 2
4 1
5 6
2 1
3 3
5 1

20
5 1
4 2
4 2
4 2
4 2
3 3
3 3
3 3
3 3
3 3
3 3
2 4
2 4
2 4
2 4
2 5
1 6
3 7
2 1
1 5

*/
