#include<bits/stdc++.h>
using namespace std;
typedef long long ll;

const int maxN = ((int) 2e5 + 5);
const int maxT = ((int) 2e6 + 5);

int n, l, brRaz;
int a[maxN];
int t[maxT];
ll s, trenS;
int pr, dr;
ll prSum, drSum;
ll sol;
vector<ll> grupe[maxN];

int parovi(int x) {
    if(x % 2 == 0)
        return x / 2 * (x - 1);
    return (x - 1) / 2 * x;
}

int main() {
    /* slozenost O((n / l) log (n / l))
    n / l moze biti najvise 2e5, a to je 0,03s za 10 ^ 8 op/s (OK) */
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> l;
    for(int i = 0; i < n; ++i) { // n
        cin >> a[i];
        s += a[i];
        ++t[a[i]];
        grupe[i % l].push_back(a[i]);
    }

    if(l == 1) {
        cout << parovi(n);
        return 0;
    }
    if(s % l != 0) {
        cout << 0;
        return 0;
    }

    s /= l;

    pr = dr = -1;
    for(int i = 0; i < l; ++i) { // izgleda kao n ^ 2, ali je samo n
        trenS = 0;
        for(int j = 0; j < grupe[i].size(); ++j)
            trenS += grupe[i][j];
        if(trenS != s) {
            ++brRaz;
            if(pr == -1) {
                pr = i;
                prSum = trenS;
            }
            else {
                dr = i;
                drSum = trenS;
            }
        }

        if(brRaz > 2) {
            cout << 0;
            return 0;
        }
    }

    if(brRaz != 2 && brRaz != 0) {
        cout << 0;
        return 0;
    }

    if(brRaz == 0) {
        for(int i = 0; i < maxT; ++i) // maxT
            sol += parovi(t[i]);
        cout << sol;
        return 0;
    }

    sort(grupe[dr].begin(), grupe[dr].end()); // (n / l) log (n / l)

    for(int i = 0; i < grupe[pr].size(); ++i) { // (n / l)
        ll x = s - (prSum - grupe[pr][i]);
        int levi = distance(grupe[dr].begin(), lower_bound(grupe[dr].begin(), grupe[dr].end(), x)); // log (n / l)
        int desni = distance(grupe[dr].begin(), upper_bound(grupe[dr].begin(), grupe[dr].end(), x));
        sol += (desni - levi);
    }

    cout << sol;
    return 0;
}
