#include <stdio.h>
#include <stdlib.h>

#define MAGZ 1268
unsigned int a[MAGZ], b[(MAGZ * (MAGZ + 1)) / 2];

int countBits(unsigned int x)
{
    int i = 0;
    while (x)
    {
        x = (x - 1) & x;
        ++i;
    }

    return i;
}

int cmp(const void *a, const void *b)
{
    int cba = countBits(*(unsigned int *)a), cbb = countBits(*(unsigned int *)b);

    if (cba > cbb)
    {
        return 1;
    }
    if (cba == cbb)
    {
        return *(unsigned int *)a - *(unsigned int *)b;
    }
    return -1;
}

int main()
{
    int n, m;
    scanf("%u", &n);
    m = n * (n + 1) / 2;
    for (int i = 0; i < m; ++i)
        scanf("%u", &b[i]);
    qsort(b, m, sizeof(unsigned int), &cmp);
    for (int i = 0; i < n; ++i)
    {
        if (b[i] == b[i-1])
        {
            n++;
        }
        else
        {
            printf("%u ", b[i]);
        }
    }
    return 0;
}
