#include <iostream>
#include <math.h>
#include <unordered_set>
#include <vector>

// Burny was here 53729

using namespace std;

unsigned long long suma_cifara(unsigned long long a)
{
    unsigned long long s=0;
    while(a>0)
    {
        s+=a%10;
        a/=10;
    }
    return s;
}

unsigned long long min_broj(unsigned long long a)
{
    int fac=1,br=0;
    while(a>=9)
    {
        br+=fac*9;
        fac*=10;
        a-=9;
    }
    br+=fac*a;
    return br;
}

unsigned long long A,B,S,K;
unsigned long long brS=0;
unsigned long long SlepiMod[1000007]={0};
unordered_set<unsigned long long> Mods;

int main()
{
    iostream::sync_with_stdio(false);
    cin.tie(0);

    cin>>A>>B>>S>>K;

    unsigned long long start=max(A,min_broj(S));

    while(suma_cifara(start)!=S){start++;}

    for(unsigned long long i=start;i<=B;i+=9)
    {
        if(suma_cifara(i)==S){SlepiMod[i%K]++; Mods.insert(i%K);}
    }
    vector<unsigned long long> VMods;
    VMods.resize(Mods.size());
    unsigned long long vc=0;
    for(auto x : Mods)
    {
        VMods[vc]=x;
        vc++;
    }

    for(unsigned long long x=0;x<vc;x++)
    {
        for(unsigned long long y=x;y<vc;y++)
        {
            if((VMods[x]*VMods[y])%K==0)
            {
                if(VMods[x]==VMods[y]){brS+=(SlepiMod[VMods[x]]*(SlepiMod[VMods[x]]+1))/2;}
                else{brS+=SlepiMod[VMods[x]]*SlepiMod[VMods[y]];}
            }
        }
    }


    cout<<brS;
    return 0;
}
