#include <bits/stdc++.h>

typedef unsigned long long __uint64;

using namespace std;

bool solved = false;

int check_unique(pair<int, int> a, vector<bool> &b)
{
    if((a.first == a.second) && b[a.first])
        return 0;
    if(b[a.first] && b[a.second])
        return 0;
    if(b[a.first] || b[a.second])
        return 1;
    return 2;
}

void solve(map<int, vector<pair<int, int>>> &table, int remaining, int l, int curr, int curri, vector<bool> uniq,  vector<bool> uniq2, vector<int> candidates, int ccurr, vector<int> arr)
{
    if(remaining < 0)
    {
        if(curr >= l - 1)
        {
            if(ccurr == candidates.size() - 1)
            {
                if(!(uniq[table[arr[curr]][curri].first]))
                    candidates[ccurr] = table[arr[curr]][curri].first;
                else
                    candidates[ccurr] = table[arr[curr]][curri].second;
            }
            else if(ccurr == candidates.size() - 2)
            {
                candidates[ccurr] = table[arr[curr]][curri].first;
                candidates[ccurr + 1] = table[arr[curr]][curri].second;
            }
            if(!solved)
            {
                for(int i = 0; i < candidates.size(); i++)
                {
                    for(int j = i; j < candidates.size(); j++)
                    {
                        uniq2[candidates[i] | candidates[j]] = true;
                    }
                }
                for(int i = 0; i < arr.size(); i++)
                {
                    if(!uniq2[arr[i]])
                        return;
                }
                for(int i = 0; i < candidates.size(); i++)
                {
                    cout << candidates[i] << ' ';
                    solved = true;
                }
            }
        }
    }
    else
    {
        if(curr == -1)
        {
            for(int i = 0; i < table[arr[0]].size(); i++)
            {
                solve(table, remaining - check_unique(table[arr[0]][i], uniq), l, 0, i, uniq, uniq2, candidates, ccurr, arr);
            }
        }
        else
        {
            if(!(uniq[table[arr[curr]][curri].first]))
            {
                candidates[ccurr] = table[arr[curr]][curri].first;
                uniq[table[arr[curr]][curri].first] = true;
                ccurr++;
            }
            if(!(uniq[table[arr[curr]][curri].second]))
            {
                candidates[ccurr] = table[arr[curr]][curri].second;
                uniq[table[arr[curr]][curri].second] = true;
                ccurr++;
            }
            int si = table[arr[curr + 1]].size();
            for(int i = 0; i < si; i++)
            {
                solve(table, remaining - check_unique(table[arr[curr + 1]][i], uniq), l, curr + 1, i, uniq, uniq2, candidates, ccurr, arr);
            }
        }
    }
}

int nextpow(int a)
{
    int p = 1;
    while(p * 2 < a)
        p *= 2;
    return p;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);

    int n;
    cin >> n;

    vector<int> b;

    int len = (n * (n + 1)) / 2;

    for(int i = 0; i < len; i++)
    {
        int bi;
        cin >> bi;
        b.push_back(bi);
    }

    map<int, vector<pair<int, int>>> dp;

    for(int i = 0; i < len; i++)
    {
        dp.insert(make_pair(b[i], vector<pair<int, int>>()));
        int t = b[i];
        while(t > 1)
        {
            int tt = nextpow(t);
            dp[b[i]].push_back(make_pair(tt, b[i] - tt));
            t -= tt;
        }
        dp[b[i]].push_back(make_pair(b[i], b[i]));
        dp[b[i]].push_back(make_pair(b[i], 0));
        dp[b[i]].push_back(make_pair(b[i], 1));
    }

    int m = LONG_MIN;

    for(int i = 0; i < len; i++)
    {
        if(b[i] > m)
            m = b[i];
    }

    vector<bool> v(m + 1, false);
    vector<bool> vv(m + 1, false);
    vector<int> c(n, 0);

    solve(dp, n, len, -1, 0, v, vv, c, 0, b);

    cout.flush();

    return 0;
}
