#include<iostream>
#include<algorithm>
#include<vector>
#include<stdio.h>

#define MAX_N 1000000

using namespace std;

typedef unsigned int uint;

int cmp(const void* p1, const void* p2){
    int v1 = *(uint*)p1;
    int v2 = *(uint*)p2;

    return v1 - v2;
}

void input(uint a[], int &n, int &m){
    scanf("%d", &n);
    m = (n*(n+1)) / 2 ;
    for(int i=0;i<m;i++)
        scanf("%d", &a[i]);
}

void output(uint* a, int n){
    for(int i=0;i<n;i++)
        printf("%d ", a[i]);
    printf("\n");
}

void debugOut(uint a[], int n){
    for(int i=0;i<n;i++)
        cout << a[i] << " ";
    cout << endl;
}

int main(){
    vector<uint> a;
    a.clear();
    uint b[MAX_N];
    uint tmp;
    uint res;
    int n;
    int m;
    input(b, n, m);

    qsort(b, m, sizeof(uint), &cmp);

    a.push_back(b[0]);
    unsigned int checker = b[0];

    for(int i=1;i<m;i++){
        if(!(checker & b[i])){
            a.push_back(b[i]);
            checker = checker | b[i];
        }
        if(a.size() == n)
            break;
    }

    if(a.size() == n)
        output(a.data(), a.size());
    else
        printf("%d\n", -1);

    return 0;
}
