#include <bits/stdc++.h>

using namespace std;

#define MAXN 2505

int freq[MAXN][28];
char input[MAXN];

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0);

    int n;
    cin >> n;

    // First word
    cin >> input[0];
    freq[0][input[0]-65] = 1;

    for (int i = 1; i < n; i++) {
        // Read the i-th word (0-indexed)
        for (int j = 0; j <= i; j++) {
            // Read the letter and increment its frequency
            cin >> input[j];
            // Subtract 65 to map from ASCII 65-90 to 0-25
            freq[i][input[j]-65]++;
        }

        // Compute the difference in frequencies of words i and i-1
        // by checking each character's frequency
        int count = 0;
        for (char l = 0; l < 26; l++) {
            count += abs(freq[i][l] - freq[i-1][l]);
            // More than one difference, this word does not belong to the pyramid
            if (count > 1) {
                cout << i;
                return 0;
            }
        }
    }

    cout << n;

    return 0;
}
