#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 2 * (1e5 + 5), MAXI = 2 * (1e6 + 2);
ll n, l, a[MAXN];
ll sum[MAXN], res, fact[MAXI], rep[MAXI];

vector<ll> idx[MAXN];
map<ll, ll> cnt;


void nchoose2(){
    fact[2] = 1;
    for(int i = 3; i < n; i++){
        if(i & 1){
            fact[i] = i * ((i - 1) >> 1);
        } else {
            fact[i] = (i >> 1) * (i - 1);
        }
    }
}

int main(){
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cin >> n >> l;
    for(int i = 1; i <= n; i++){
        cin >> a[i];
        idx[i % l].push_back(i);
        sum[i % l] += a[i];
    }

    for(int i = 0; i < l; i++){
        cnt[sum[i]]++;
    }
    if(cnt.size() > 3){
        cout << 0;
        return 0;
    }
    for(int i = 1; i <= n; i++){
        rep[a[i]]++;
    }
    if(cnt.size() == 1){
        nchoose2();
        long long res = 0;
        for(int i = 1; i <= n; i++){
            if(rep[i] >= 2){
                res += fact[rep[i]];
            }
        }
        cout << res;
        return 0;
    } else if(cnt.size() == 2){
        auto tmp = cnt.begin();
        int k = (*tmp).first;
        tmp++;
        k += (*tmp).first;
        k >>= 1;
        for(int i = 0; i < l; i++){
            map<int, int> minicnt;
            for(int p : idx[i])
                minicnt[a[p]]++;

            for(int p : idx[i]){
                res += max(0LL, rep[k - (sum[i] - a[p])] - minicnt[a[p]]);
            }
        }

    } else if(cnt.size() == 3){
        res = 0;
    }

    cout << res;
    return 0;
}
